using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Concord.API.Future.ClientSample.Elves
{
    struct FFCommoymElf
    {
        public string 交易所代碼 { get; set; }
        public string 商品代號 { get; set; }
        public string 月份 { get; set; }
        public string 交割月份 { get; set; }
        public string 熱門月份 { get; set; }
        public string 最後交易日 { get; set; }
        public string 商品別 { get; set; }
        public string 買賣權 { get; set; }
        public string 履約價 { get; set; }
    }
    public struct FFCommoymKeyElf
    {
        public FFCommoymKeyElf(string 月份, string 履約價, string 買賣權)
        {
            this.月份 = 月份;
            this.履約價 = 履約價;
            this.買賣權 = 買賣權;
        }
        public string 月份 { get; set; }
        public string 履約價 { get; set; }
        public string 買賣權 { get; set; }
    }
    public class FFCommoymKeyElfComparer : IComparer<FFCommoymKeyElf>
    {
        public int Compare(FFCommoymKeyElf x, FFCommoymKeyElf y)
        {
            int x月份 = int.Parse(x.月份);
            int y月份 = int.Parse(y.月份);
            if (x月份 > y月份)
            {
                return 1;
            }
            else
            {
                if (x月份 == y月份)
                {
                    double x履約價 = double.Parse(x.履約價);
                    double y履約價 = double.Parse(y.履約價);
                    if (x履約價 > y履約價)
                    {
                        return 1;
                    }
                    else
                    {
                        if (x履約價 < y履約價)
                        {
                            return -1;
                        }
                        else
                        {
                            return string.Compare(x.買賣權, y.買賣權);
                        }
                    }
                }
                else
                {
                    return -1;
                }
            }
        }
    }
}
